#pragma DATA_ACQUISITION_BASE_H
#include "../../../tool/singleton.h"
#include "../../../error_code/error_code.h"

class DataAcquisition {
public:
    enum CLOUD_TYPE {
        CLOUD_BIN_TYPE = 0
    };
public:
    static DataAcquisition* Instance() {
        static DataAcquisition* instance = new DataAcquisition();
        return instance;
    }

	virtual Error_manager init();
	virtual Error_manager init_from_protobuf(std::string prototxt_path);
	virtual Error_manager uninit();

    private:
    
    Error_manager GetDeviceData();
    Error_manager Format2CloudType(CLOUD_TYPE& type, const char* data);
    Error_manager SendData2Cloud(const char* data);
    Error_manager Data2Binary(const char*data);
    void run();

protected:
    DataAcquisition();
    ~DataAcquisition();
};