//
// Created by zx on 23-2-22.
//

#include "paho_client.h"
#include "mqttmsg.h"
#include "point_tool.h"
#include <pcl/common/transforms.h>
#include <pcl/visualization/pcl_visualizer.h>
#define QOS 1




int main(int argc,char* argv[])
{
  Paho_client client("nodeaa");
  client.set_maxbuf(10000*12);
  client.connect("192.168.2.132",1883);

  pcl::PointCloud<pcl::PointXYZ>::Ptr cloud=ReadTxtCloud("./two_lidar.txt");
  float x=0;
  float theta=0;

  pcl::visualization::PCLVisualizer viewer ("ssssss");

  while(1)
  {
    theta+=(M_PI*0.5/180.0);
    Eigen::Affine3f transform_2 = Eigen::Affine3f::Identity();

    // Define a translation of 2.5 meters on the x axis.
    transform_2.translation() << 0, 0.0, 0.0;

    // The same rotation matrix as before; theta radians arround Z axis
    transform_2.rotate (Eigen::AngleAxisf (theta, Eigen::Vector3f::UnitZ()));

    pcl::PointCloud<pcl::PointXYZ>::Ptr transformed_cloud (new pcl::PointCloud<pcl::PointXYZ> ());
    // 你可以使用 transform_1 或者 transform_2;效果都是一样的
    pcl::transformPointCloud (*cloud, *transformed_cloud, transform_2);

    MqttMsg msg;
    msg.fromPclPointCloud(transformed_cloud);
    client.publish("cloudaa",QOS,msg);
    viewer.removeAllPointClouds();
    pcl::visualization::PointCloudColorHandlerCustom<pcl::PointXYZ> transformed_cloud_color_handler (transformed_cloud, 255, 255, 255); // Red
    viewer.addPointCloud (transformed_cloud, transformed_cloud_color_handler, "transformed_cloud");
    printf(" client send :%f  BYTES:%d\n",x,msg.length());

    viewer.spinOnce ();
    usleep(1000*10);
  }
}
