//
// Created by zx on 23-2-22.
//

#ifndef PAHOC_SAMPLE_SAMPLES_DEVICE_MSG_H_
#define PAHOC_SAMPLE_SAMPLES_DEVICE_MSG_H_

#include <pcl/io/io.h>
#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>
#include <pcl/common/io.h>
#include <pcl/common/common.h>
#include <mutex>


class MqttMsg
{
 public:
    enum Dtype
    {
      ePointCloudXYZ,
      ePointCloudXYZI,
      eString,
      eImage
    };
 public:
    MqttMsg();
    MqttMsg(char* data,const int length);
    MqttMsg(const MqttMsg& msg);
    MqttMsg& operator=(const MqttMsg& msg);
    ~MqttMsg();

    char* data()const;
    int length()const;

    void fromPclPointCloud(pcl::PointCloud<pcl::PointXYZ>::Ptr cloud);

    bool toPclCloud(pcl::PointCloud<pcl::PointXYZ>::Ptr cloud);
    bool toPclCloud(pcl::PointCloud<pcl::PointXYZI>::Ptr cloud);
    bool toPclCloud(pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud);

 protected:
    char* data_=nullptr;
    int length_=0;
    std::mutex mutex_;

};


#endif //PAHOC_SAMPLE_SAMPLES_DEVICE_MSG_H_
