//
// Created by zx on 23-2-22.
//

#include "paho_client.h"
#include "mqttmsg.h"
#include <pcl/visualization/pcl_visualizer.h>
#define QOS 1

pcl::PointCloud<pcl::PointXYZ>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZ>);
int new_arrived=0;
void callback(std::string topic,int qos,MqttMsg& msg)
{
  printf("arrived\n");

  msg.toPclCloud(cloud);
  new_arrived=1;
  if(cloud->size()>=1)
  {
    printf(" arrived pt:%d  x:%f\n",cloud->size(),cloud->points[0].x);
  }
}

int main(int argc,char* argv[])
{
  Paho_client client("nodeaabb");
  client.set_maxbuf(10000*12);
  client.connect("192.168.2.132",1883);

  while(!client.isconnected()) usleep(1000);
  client.subcribe("cloudaa",QOS,callback);

  pcl::visualization::PCLVisualizer viewer ("recv");
  while(1)
  {
    if(new_arrived==1)
    {
      viewer.removeAllPointClouds();
      pcl::visualization::PointCloudColorHandlerCustom<pcl::PointXYZ> transformed_cloud_color_handler (cloud, 255, 255, 255); // Red
      viewer.addPointCloud (cloud, transformed_cloud_color_handler, "cloud_recv");
    }
    viewer.spinOnce ();
    usleep(1000*1);
  }
}
